image: docker:stable

stages:
  - build
  - docker
  - deploy

variables:
  IMAGE: $CI_REGISTRY_IMAGE:$CI_COMMIT_REF_NAME
  IMAGE_LATEST: $CI_REGISTRY_IMAGE:latest
  GIT_DEPTH: 1
  GIT_CLEAN_FLAGS: -ffdx -e target/ -e Cargo.lock


compile:
  stage: build
  image: pashinin/rust-build:2021-09-17
  script:
    - cargo build --release
  tags: [concurrent-1-0]
  artifacts:
    paths: [ ./target/release/api-deploy-rs ]


docker:
  stage: docker
  needs: ["compile"]
  image: docker:stable
  dependencies: [ compile ]
  services:
    - docker:dind
  before_script: [echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY]
  script:
    - docker build --tag $IMAGE .
    - docker push $IMAGE
  only:
    - tags
  tags: [concurrent-1-0]


docker image latest:
  stage: docker
  needs: ["compile"]
  image: docker:stable
  dependencies: [ compile ]
  services:
    - docker:dind
  before_script: [echo -n $CI_JOB_TOKEN | docker login -u gitlab-ci-token --password-stdin $CI_REGISTRY]
  script:
    - docker build --tag $IMAGE_LATEST .
    - docker push $IMAGE_LATEST
  only:
    - master
  tags: [concurrent-1-0]


deploy stable:
  stage: deploy
  image: curlimages/curl:7.75.0
  variables:
    GIT_STRATEGY: none
  dependencies: []
  script:
    - curl --fail -L -H "Content-Type:application/json" -H "DEPLOY_TOKEN:$DEPLOY_TOKEN" --data "{\"project_url\":\"$CI_PROJECT_URL\",\"tag\":\"$CI_COMMIT_TAG\"}" https://api.pashinin.com/deploy
  when: manual
  only:
    - tags
  environment:
    name: production
    url: https://api.pashinin.com/deploy
  tags: [ concurrent-4-0 ]


deploy latest:
  stage: deploy
  # image: curlimages/curl:7.75.0
  image: inutano/wget
  variables:
    GIT_STRATEGY: none
  dependencies: []
  script:
    # - curl --fail -L -H "Content-Type:application/json" -H "DEPLOY_TOKEN:$DEPLOY_TOKEN" --data "{\"project_url\":\"$CI_PROJECT_URL\"}" https://api.pashinin.com/deploy
    - wget --post-data="{\"project_url\":\"$CI_PROJECT_URL\"}" --content-on-error --header="Content-Type:application/json" --header="DEPLOY_TOKEN:$DEPLOY_TOKEN" -qO- https://api.pashinin.com/deploy
  only:
    - master
  environment:
    name: latest
    url: https://api-latest.pashinin.com/deploy
  tags: [ concurrent-4-0 ]
